---
title: Update an annotation
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Annotations
---

# Update an annotation{% #update-an-annotation %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                        |
| ----------------- | ------------------------------------------------------------------- |
| ap1.datadoghq.com | PUT https://api.ap1.datadoghq.com/api/v2/annotation/{annotation_id} |
| ap2.datadoghq.com | PUT https://api.ap2.datadoghq.com/api/v2/annotation/{annotation_id} |
| app.datadoghq.eu  | PUT https://api.datadoghq.eu/api/v2/annotation/{annotation_id}      |
| app.ddog-gov.com  | PUT https://api.ddog-gov.com/api/v2/annotation/{annotation_id}      |
| us2.ddog-gov.com  | PUT https://api.us2.ddog-gov.com/api/v2/annotation/{annotation_id}  |
| app.datadoghq.com | PUT https://api.datadoghq.com/api/v2/annotation/{annotation_id}     |
| us3.datadoghq.com | PUT https://api.us3.datadoghq.com/api/v2/annotation/{annotation_id} |
| us5.datadoghq.com | PUT https://api.us5.datadoghq.com/api/v2/annotation/{annotation_id} |

### Overview

Updates an existing annotation. Valid `color` values: `gray`, `blue`, `purple`, `green`, `yellow`, `red`. Valid `type` values: `pointInTime` (marks a single moment) or `timeRegion` (spans a range and requires `end_time`).

### Arguments

#### Path Parameters

| Name                            | Type   | Description               |
| ------------------------------- | ------ | ------------------------- |
| annotation_id [*required*] | string | The ID of the annotation. |

### Request

#### Body Data (required)

Updated annotation payload.

{% tab title="Model" %}

| Parent field | Field                         | Type     | Description                                                                                                                                                                                               |
| ------------ | ----------------------------- | -------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]        | object   | Data for creating an annotation.                                                                                                                                                                          |
| data         | attributes [*required*]  | object   | Attributes for creating or updating an annotation.                                                                                                                                                        |
| attributes   | color [*required*]       | enum     | Color used to render the annotation in the UI. Allowed enum values: `gray,blue,purple,green,yellow,red`                                                                                                   |
| attributes   | description [*required*] | string   | User-defined text attached to the annotation.                                                                                                                                                             |
| attributes   | end_time                      | int64    | End time of the annotation in milliseconds since the Unix epoch. Required for `timeRegion` annotations; omit or set to null for `pointInTime` annotations.                                                |
| attributes   | page_id [*required*]     | string   | ID of the page the annotation belongs to, prefixed with the page type and joined by a colon (for example, `dashboard:abc-def-xyz` or `notebook:1234567890`).                                              |
| attributes   | start_time [*required*]  | int64    | Start time of the annotation in milliseconds since the Unix epoch.                                                                                                                                        |
| attributes   | type [*required*]        | enum     | Kind of annotation. `pointInTime` annotations mark a single moment in time, while `timeRegion` annotations span a window of time and require an `end_time`. Allowed enum values: `pointInTime,timeRegion` |
| attributes   | widget_ids                    | [string] | IDs of widgets the annotation is associated with. When empty or omitted, the annotation applies to the whole page.                                                                                        |
| data         | type [*required*]        | enum     | Annotation resource type. Allowed enum values: `annotation`                                                                                                                                               |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "color": "green",
      "description": "Updated annotation.",
      "page_id": "dashboard:abc-def-xyz",
      "start_time": 1704067200000,
      "type": "pointInTime"
    },
    "type": "annotation"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing a single annotation.

| Parent field | Field                         | Type     | Description                                                                                                                                                                                               |
| ------------ | ----------------------------- | -------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]        | object   | A single annotation resource.                                                                                                                                                                             |
| data         | attributes [*required*]  | object   | Attributes of an annotation returned in a response.                                                                                                                                                       |
| attributes   | author_id [*required*]   | string   | Identifier of the user who created the annotation.                                                                                                                                                        |
| attributes   | color [*required*]       | enum     | Color used to render the annotation in the UI. Allowed enum values: `gray,blue,purple,green,yellow,red`                                                                                                   |
| attributes   | created_at [*required*]  | int64    | Creation time of the annotation in milliseconds since the Unix epoch.                                                                                                                                     |
| attributes   | description [*required*] | string   | User-defined text attached to the annotation.                                                                                                                                                             |
| attributes   | end_time [*required*]    | int64    | End time of the annotation in milliseconds since the Unix epoch. Null for `pointInTime` annotations.                                                                                                      |
| attributes   | modified_at [*required*] | int64    | Last modification time of the annotation in milliseconds since the Unix epoch.                                                                                                                            |
| attributes   | page_id [*required*]     | string   | ID of the page the annotation belongs to, prefixed with the page type and joined by a colon (for example, `dashboard:abc-def-xyz` or `notebook:1234567890`).                                              |
| attributes   | start_time [*required*]  | int64    | Start time of the annotation in milliseconds since the Unix epoch.                                                                                                                                        |
| attributes   | type [*required*]        | enum     | Kind of annotation. `pointInTime` annotations mark a single moment in time, while `timeRegion` annotations span a window of time and require an `end_time`. Allowed enum values: `pointInTime,timeRegion` |
| attributes   | widget_ids                    | [string] | IDs of widgets the annotation is associated with. When empty or omitted, the annotation applies to the whole page.                                                                                        |
| data         | id [*required*]          | uuid     | Unique identifier of the annotation.                                                                                                                                                                      |
| data         | type [*required*]        | enum     | Annotation resource type. Allowed enum values: `annotation`                                                                                                                                               |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "author_id": "00000000-0000-0000-0000-000000000000",
      "color": "blue",
      "created_at": 1704067200000,
      "description": "Deployed v2.3.1 to production.",
      "end_time": 1704070800000,
      "modified_at": 1704067200000,
      "page_id": "dashboard:abc-def-xyz",
      "start_time": 1704067200000,
      "type": "pointInTime",
      "widget_ids": [
        "1234567890"
      ]
    },
    "id": "00000000-0000-0000-0000-000000000000",
    "type": "annotation"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="500" %}
Internal Server Error
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Path parameters export annotation_id="00000000-0000-0000-0000-000000000000" \# Curl command curl -X PUT "https://api.datadoghq.com/api/v2/annotation/${annotation_id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "color": "green",
      "description": "Deployed v2.3.1 to production (updated).",
      "page_id": "dashboard:abc-def-xyz",
      "start_time": 1704067200000,
      "type": "pointInTime",
      "widget_ids": [
        "1234567890"
      ]
    },
    "type": "annotation"
  }
}
EOF 
                        
##### 

```go
// Update an annotation returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	// there is a valid "annotation" in the system
	AnnotationDataID := uuid.MustParse(os.Getenv("ANNOTATION_DATA_ID"))

	body := datadogV2.AnnotationUpdateRequest{
		Data: datadogV2.AnnotationRequestData{
			Attributes: datadogV2.AnnotationCreateAttributes{
				Color:       datadogV2.ANNOTATIONCOLOR_GREEN,
				Description: "Updated annotation.",
				PageId:      "dashboard:abc-def-xyz",
				StartTime:   1704067200000,
				Type:        datadogV2.ANNOTATIONKIND_POINT_IN_TIME,
			},
			Type: datadogV2.ANNOTATIONTYPE_ANNOTATION,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.UpdateAnnotation", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewAnnotationsApi(apiClient)
	resp, r, err := api.UpdateAnnotation(ctx, AnnotationDataID, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `AnnotationsApi.UpdateAnnotation`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `AnnotationsApi.UpdateAnnotation`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Update an annotation returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.AnnotationsApi;
import com.datadog.api.client.v2.model.AnnotationColor;
import com.datadog.api.client.v2.model.AnnotationCreateAttributes;
import com.datadog.api.client.v2.model.AnnotationKind;
import com.datadog.api.client.v2.model.AnnotationRequestData;
import com.datadog.api.client.v2.model.AnnotationResponse;
import com.datadog.api.client.v2.model.AnnotationType;
import com.datadog.api.client.v2.model.AnnotationUpdateRequest;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.updateAnnotation", true);
    AnnotationsApi apiInstance = new AnnotationsApi(defaultClient);

    // there is a valid "annotation" in the system
    UUID ANNOTATION_DATA_ID = null;
    try {
      ANNOTATION_DATA_ID = UUID.fromString(System.getenv("ANNOTATION_DATA_ID"));
    } catch (IllegalArgumentException e) {
      System.err.println("Error parsing UUID: " + e.getMessage());
    }

    AnnotationUpdateRequest body =
        new AnnotationUpdateRequest()
            .data(
                new AnnotationRequestData()
                    .attributes(
                        new AnnotationCreateAttributes()
                            .color(AnnotationColor.GREEN)
                            .description("Updated annotation.")
                            .pageId("dashboard:abc-def-xyz")
                            .startTime(1704067200000L)
                            .type(AnnotationKind.POINT_IN_TIME))
                    .type(AnnotationType.ANNOTATION));

    try {
      AnnotationResponse result = apiInstance.updateAnnotation(ANNOTATION_DATA_ID, body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling AnnotationsApi#updateAnnotation");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
"""
Update an annotation returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.annotations_api import AnnotationsApi
from datadog_api_client.v2.model.annotation_color import AnnotationColor
from datadog_api_client.v2.model.annotation_create_attributes import AnnotationCreateAttributes
from datadog_api_client.v2.model.annotation_kind import AnnotationKind
from datadog_api_client.v2.model.annotation_request_data import AnnotationRequestData
from datadog_api_client.v2.model.annotation_type import AnnotationType
from datadog_api_client.v2.model.annotation_update_request import AnnotationUpdateRequest

# there is a valid "annotation" in the system
ANNOTATION_DATA_ID = environ["ANNOTATION_DATA_ID"]

body = AnnotationUpdateRequest(
    data=AnnotationRequestData(
        attributes=AnnotationCreateAttributes(
            color=AnnotationColor.GREEN,
            description="Updated annotation.",
            page_id="dashboard:abc-def-xyz",
            start_time=1704067200000,
            type=AnnotationKind.POINT_IN_TIME,
        ),
        type=AnnotationType.ANNOTATION,
    ),
)

configuration = Configuration()
configuration.unstable_operations["update_annotation"] = True
with ApiClient(configuration) as api_client:
    api_instance = AnnotationsApi(api_client)
    response = api_instance.update_annotation(annotation_id=ANNOTATION_DATA_ID, body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Update an annotation returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.update_annotation".to_sym] = true
end
api_instance = DatadogAPIClient::V2::AnnotationsAPI.new

# there is a valid "annotation" in the system
ANNOTATION_DATA_ID = ENV["ANNOTATION_DATA_ID"]

body = DatadogAPIClient::V2::AnnotationUpdateRequest.new({
  data: DatadogAPIClient::V2::AnnotationRequestData.new({
    attributes: DatadogAPIClient::V2::AnnotationCreateAttributes.new({
      color: DatadogAPIClient::V2::AnnotationColor::GREEN,
      description: "Updated annotation.",
      page_id: "dashboard:abc-def-xyz",
      start_time: 1704067200000,
      type: DatadogAPIClient::V2::AnnotationKind::POINT_IN_TIME,
    }),
    type: DatadogAPIClient::V2::AnnotationType::ANNOTATION,
  }),
})
p api_instance.update_annotation(ANNOTATION_DATA_ID, body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```rust
// Update an annotation returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_annotations::AnnotationsAPI;
use datadog_api_client::datadogV2::model::AnnotationColor;
use datadog_api_client::datadogV2::model::AnnotationCreateAttributes;
use datadog_api_client::datadogV2::model::AnnotationKind;
use datadog_api_client::datadogV2::model::AnnotationRequestData;
use datadog_api_client::datadogV2::model::AnnotationType;
use datadog_api_client::datadogV2::model::AnnotationUpdateRequest;

#[tokio::main]
async fn main() {
    // there is a valid "annotation" in the system
    let annotation_data_id =
        uuid::Uuid::parse_str(&std::env::var("ANNOTATION_DATA_ID").unwrap()).expect("Invalid UUID");
    let body = AnnotationUpdateRequest::new(AnnotationRequestData::new(
        AnnotationCreateAttributes::new(
            AnnotationColor::GREEN,
            "Updated annotation.".to_string(),
            "dashboard:abc-def-xyz".to_string(),
            1704067200000,
            AnnotationKind::POINT_IN_TIME,
        ),
        AnnotationType::ANNOTATION,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.UpdateAnnotation", true);
    let api = AnnotationsAPI::with_config(configuration);
    let resp = api
        .update_annotation(annotation_data_id.clone(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Update an annotation returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.updateAnnotation"] = true;
const apiInstance = new v2.AnnotationsApi(configuration);

// there is a valid "annotation" in the system
const ANNOTATION_DATA_ID = process.env.ANNOTATION_DATA_ID as string;

const params: v2.AnnotationsApiUpdateAnnotationRequest = {
  body: {
    data: {
      attributes: {
        color: "green",
        description: "Updated annotation.",
        pageId: "dashboard:abc-def-xyz",
        startTime: 1704067200000,
        type: "pointInTime",
      },
      type: "annotation",
    },
  },
  annotationId: ANNOTATION_DATA_ID,
};

apiInstance
  .updateAnnotation(params)
  .then((data: v2.AnnotationResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
